import { SideEffect2 } from "@reactive-js/core/lib/functions";
import { IOSourceLike } from "@reactive-js/core/lib/io";
import { CacheDirective } from "./cacheDirective";
import { HttpContentInfo } from "./httpContentInfo";
import { HttpHeaders } from "./httpHeaders";
import { HttpPreferences } from "./httpPreferences";
export interface URILike {
    readonly hash: string;
    readonly host: string;
    readonly hostname: string;
    readonly href: string;
    readonly origin: string;
    readonly pathname: string;
    readonly port: string;
    readonly protocol: string;
    readonly search: string;
    toString(): string;
}
export declare type HttpMessage<T> = {
    readonly body: T;
    readonly cacheControl: readonly CacheDirective[];
    readonly contentInfo?: HttpContentInfo;
    readonly headers: HttpHeaders;
    readonly preferences?: HttpPreferences;
};
export declare const writeHttpMessageHeaders: <T>({ cacheControl, contentInfo, headers, preferences }: HttpMessage<T>, writeHeader: SideEffect2<string, string>) => void;
export declare const encodeHttpMessageWithUtf8: ({ contentInfo, ...msg }: HttpMessage<string>) => HttpMessage<Uint8Array>;
export declare const decodeHttpMessageWithCharset: ({ contentInfo, ...msg }: HttpMessage<Uint8Array>) => HttpMessage<string>;
export declare const toIOSourceHttpMessage: <TBody>({ body, ...msg }: HttpMessage<TBody>) => HttpMessage<IOSourceLike<TBody>>;
