import { SideEffect2 } from "@reactive-js/core/lib/functions";
import { Option } from "@reactive-js/core/lib/option";
import { HttpContentEncoding } from "./httpContentInfo";
import { HttpHeaders } from "./httpHeaders";
export declare type MediaRange = {
    readonly type: string | "*";
    readonly subtype: string | "*";
};
export declare type HttpPreferences = {
    readonly acceptedCharsets: readonly string[];
    readonly acceptedEncodings: readonly HttpContentEncoding[];
    readonly acceptedLanguages: readonly string[];
    readonly acceptedMediaRanges: readonly MediaRange[];
};
export declare const parseHttpPreferencesFromHeaders: (headers: HttpHeaders) => Option<HttpPreferences>;
export declare const createHttpPreferences: ({ acceptedCharsets, acceptedEncodings, acceptedLanguages, acceptedMediaRanges, }: {
    acceptedCharsets?: Option<readonly string[]>;
    acceptedEncodings?: readonly HttpContentEncoding[] | undefined;
    acceptedLanguages?: Option<readonly string[]>;
    acceptedMediaRanges?: readonly (string | MediaRange)[] | undefined;
}) => HttpPreferences;
export declare const writeHttpPreferenceHeaders: (preferences: HttpPreferences, writeHeader: SideEffect2<string, string>) => void;
