import { SideEffect2 } from "@reactive-js/core/lib/functions";
import { Option } from "@reactive-js/core/lib/option";
import { EntityTag } from "./entityTag";
import { HttpDateTime } from "./httpDateTime";
import { HttpHeaders } from "./httpHeaders";
export declare type HttpRequestPreconditions = {
    readonly ifMatch?: readonly EntityTag[] | "*";
    readonly ifModifiedSince?: HttpDateTime;
    readonly ifNoneMatch?: readonly EntityTag[] | "*";
    readonly ifUnmodifiedSince?: HttpDateTime;
    readonly ifRange?: EntityTag | HttpDateTime;
};
export declare const writeHttpRequestPreconditionsHeaders: ({ ifMatch, ifModifiedSince, ifNoneMatch, ifUnmodifiedSince, ifRange, }: HttpRequestPreconditions, writeHeader: SideEffect2<string, string>) => void;
export declare const parseHttpRequestPreconditionsFromHeaders: (headers: HttpHeaders) => Option<HttpRequestPreconditions>;
export declare const createHttpRequestPreconditions: ({ ifMatch, ifModifiedSince, ifNoneMatch, ifUnmodifiedSince, ifRange, }: {
    ifMatch?: "*" | readonly (string | EntityTag)[] | undefined;
    ifModifiedSince?: string | number | Date | undefined;
    ifNoneMatch?: "*" | readonly (string | EntityTag)[] | undefined;
    ifUnmodifiedSince?: string | number | Date | undefined;
    ifRange?: string | number | Date | EntityTag | undefined;
}) => HttpRequestPreconditions;
