import { SideEffect2 } from "@reactive-js/core/lib/functions";
import { Option } from "@reactive-js/core/lib/option";
import { HttpHeaders } from "./httpHeaders";
import { MediaType } from "./mediaType";
export declare const enum HttpContentEncoding {
    Brotli = "br",
    Compress = "compress",
    Deflate = "deflate",
    GZip = "gzip",
    Identity = "identity"
}
export declare type HttpContentInfo = {
    readonly contentEncodings: readonly HttpContentEncoding[];
    readonly contentLength: number;
    readonly contentType: MediaType;
};
export declare const parseHttpContentInfoFromHeaders: (headers: HttpHeaders) => Option<HttpContentInfo>;
export declare const writeHttpContentInfoHeaders: (content: HttpContentInfo, writeHeader: SideEffect2<string, string>) => void;
export declare const createHttpContentInfo: ({ contentEncodings, contentLength, contentType, }: {
    contentEncodings?: readonly HttpContentEncoding[] | undefined;
    contentLength?: number | undefined;
    contentType: string | MediaType;
}) => HttpContentInfo;
export declare const contentIsCompressible: (content: HttpContentInfo, db: {
    [key: string]: {
        compressible?: boolean | undefined;
    };
}) => boolean;
