import { Function1 } from "@reactive-js/core/lib/functions";
import { ObservableLike } from "@reactive-js/core/lib/observable";
import { HttpHeaders } from "./httpHeaders";
import { HttpMethod, HttpRequest } from "./httpRequest";
import { HttpResponse } from "./httpResponse";
export declare type HttpServerRequest<T> = HttpRequest<T> & {
    readonly isTransportSecure: boolean;
};
export declare type HttpServer<THttpRequest extends HttpRequest<unknown>, THttpResponse extends HttpResponse<unknown>> = (req: THttpRequest) => ObservableLike<THttpResponse>;
export declare type HttpRoutedRequest<T> = HttpRequest<T> & {
    readonly params: {
        readonly [param: string]: string;
    };
};
export declare const createRoutingHttpServer: <TReq, TResp>(routes: {
    [path: string]: HttpServer<HttpRoutedRequest<TReq>, HttpResponse<TResp>>;
}, notFoundHandler: Function1<HttpRequest<TReq>, ObservableLike<HttpResponse<TResp>>>) => HttpServer<HttpRequest<TReq>, HttpResponse<TResp>>;
export declare const parseHttpServerRequestFromHeaders: <T>({ method, path, headers, httpVersionMajor, httpVersionMinor, isTransportSecure, body, }: {
    method: HttpMethod;
    path: string;
    headers: HttpHeaders;
    body: T;
    httpVersionMajor: number;
    httpVersionMinor: number;
    isTransportSecure: boolean;
}) => HttpServerRequest<T>;
export declare const disallowProtocolAndHostForwarding: <T>() => Function1<HttpServerRequest<T>, HttpServerRequest<T>>;
